import * as yaml from 'js-yaml';
export type YamlFiles = ReturnType<GeneratorBase['listSourceYAMLFiles']>;
export declare abstract class GeneratorBase {
    private outputBuffer;
    private outputStream?;
    constructor();
    static loadOptions: yaml.LoadOptions;
    protected configDir: string;
    private listCategories;
    private listSourceYAMLFiles;
    protected emitToFile(filePath: string): Promise<void>;
    private flushFile;
    protected emit(str: string): void;
    protected toComment(str?: string, docsUrl?: string): string;
    protected emitComment(str: string, docsUrl?: string): void;
    protected getOutputOf(fn: () => void): string;
    protected abstract generateImpl(iterable: YamlFiles): Promise<void>;
    generate(categoryFilter?: string, operatorFilter?: string): Promise<void>;
}
//# sourceMappingURL=generator.d.ts.map